;;;
;;;www.zwcad.pl | Zmiana kolorw ta ekranu roboczego.
;;;

(defun C:szare (  / ) 
	(BGColor 30 40 48 )
	(CursorColor 255 255 255)
)
(defun C:biae (  / ) 
	(BGColor 255 255 255 )	
	(CursorColor 0 0 0 )
)
(defun c:czarne (  / ) 
	(BGColor 0 0 0 )
	(CursorColor 255 255 255)
)

(defun BGColor ( R G B / PREF ) 
	(setq PREF ( vla-get-display ( vla-get-preferences (vlax-get-acad-object ) ) ) )
	(vlax-put-property PREF 'GraphicsWinModelBackgrndColor ( RGB->Int R G B ) )
	(vlax-release-object PREF)
)

(defun CursorColor ( R G B / ) 
	( setq PREF ( vla-get-display ( vla-get-preferences (vlax-get-acad-object ) ) ) )
	(vlax-put-property PREF 'ModelCrosshairColor ( RGB->Int R G B ) )
	(vlax-release-object PREF)
)

(defun RGB->Int ( R G B  / ) 
	(+ R ( * G 256 ) ( * B 65536 ) )
)

;;--------------------------------------------------------------------------------------------------------------------------------------;;

;;;
;;;www.zwcad.pl | Skrypt przeczajcy widoczno polilinii o zadanej globalnej gruboci.
;;;

(defun C:ZZ (  / *error* )
	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nC:ZZ:*error*: " ) (princ msg ) (princ "\n")	) )
	)
	
	( if ( = (getvar "FILLMODE" ) 0 )
		(progn ( setvar "FILLMODE" 1 )(command "_REGEN") )
		(progn ( setvar "FILLMODE" 0 )  )
	)
	(princ "" )
)

;;--------------------------------------------------------------------------------------------------------------------------------------;;
;;;
;;;www.zwcad.pl | Skrypt do obrotu ukadu UCS o wskazany kt.
;;;
(defun ZWCAD:Getpoint (tresc P0 domyslny / SelPt Wynik )
;(ZWCAD:Getpoint tresc P0 domyslny )
	(setq tresc (strcat "\n" tresc ": "))
	(if (not(null P0))
		(setq SelPt(vl-catch-all-apply 'getpoint (list P0 tresc )))
		(setq SelPt(vl-catch-all-apply 'getpoint (list  tresc )))
	)
	(if (vl-catch-all-error-p SelPt)
	(progn
		(prompt (vl-catch-all-error-message SelPt))
		(setq Wynik nil )
	)
	(progn				
	  (if (null SelPt) 
		(setq Wynik domyslny )
		(setq Wynik SelPt)
	  )
	)
  )
  Wynik
)

(defun r2d (rads / )(/(* 180 rads)pi))

(defun C:UCSZ (  / *error* p1 p2 ang)
	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nC:UCS_Rotate:*error*: " ) (princ msg ) (princ "\n")	) )
	)
	(setq p1 (ZWCAD:Getpoint "Wska pierwszy punkt odniesienia"  nil nil ) )
	( if ( not (null p1 ) ) (progn
		(setq p2 (ZWCAD:Getpoint "Wska drugi punkt odniesienia" p1 nil ) )
		( if ( not (null p2 ) ) (progn
			(setq ang (angle p1 p2 ) ) 
			(command "_UCS" "_Z" (rtos (r2d ang ) ) )
		))
	))
	(princ "" )
)


;;--------------------------------------------------------------------------------------------------------------------------------------;;

;;;Odtworzenie obwiedni kreskowa
(prompt "\nOOK.lsp zaadowany, Wpisz OOK by uruchomi")
(defun c:OOK (/ OLDCE SSET CNT OBJ)
  (setq OLDCE (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (princ "\nWybierz kreskowania: ")
  (setq SSET (ssget))
  (setq CNT -1)
  (while (setq OBJ (ssname SSET (setq CNT (1+ CNT))))
(command "-hatchedit" OBJ "_b" "_p" "_y")
 )
(setvar "cmdecho" OLDCE)
(princ)
)



;;--------------------------------------------------------------------------------------------------------------------------------------;;

(vl-load-com) 

;;----------------=={ Add LWPolyline Vertex }==---------------;;
;;                                                            ;;
;;  Adds a new vertex to an LWPolyline at a point specified   ;;
;;  by the user; compatible with LWPolylines at any           ;;
;;  orientation, with varying width and arc segments.         ;;
;;------------------------------------------------------------;;
;;  Author: Lee Mac, Copyright  2012 - www.lee-mac.com       ;;
;;------------------------------------------------------------;;
;;  Version 1.0    -    17-12-2012                            ;;
;;                                                            ;;
;;  First release.                                            ;;
;;------------------------------------------------------------;;

(defun c:apv ( / a b e h l n p r w x z )
    (while
        (progn (setq p (getpoint "\nPick Point for New Vertex: "))
            (cond
                (   (null p) nil)
                (   (null (setq e (nentselp p)))
                    (princ "\nPoint does not lie on an LWPolyline.")
                )
                (   (= 4 (length e))
                    (princ "\nObject is Nested.")
                )
                (   (/= "LWPOLYLINE" (cdr (assoc 0 (entget (setq e (car e))))))
                    (princ "\nObject is not an LWPolyline.")
                )
            )
        )
    )
    (if (and p e
            (setq p (vlax-curve-getclosestpointto e (trans p 1 0))
                  n (vlax-curve-getparamatpoint e p)
            )
        )
        (if (not (equal n (fix n) 1e-8))
            (progn
                (setq e (entget e)
                      h (reverse (member (assoc 39 e) (reverse e)))
                      l (LM:LWVertices e)
                      z (assoc 210 e)
                )
                (repeat (fix n)
                    (setq a (cons (car l) a)
                          l (cdr l)
                    )
                )
                (setq x (car l)
                      r (- n (fix n))
                      w (cdr (assoc 40 x))
                      w (+ w (* r (- (cdr (assoc 41 x)) w)))
                      b (atan (cdr (assoc 42 x)))
                )
                (entmod
                    (append h
                        (apply 'append (reverse a))
                        (list
                            (assoc 10 x)
                            (assoc 40 x)
                            (cons  41 w)
                            (cons  42 (tan (* r b)))
                        )
                        (list
                            (cons  10 (trans p 0 (cdr z)))
                            (cons  40 w)
                            (assoc 41 x)
                            (cons  42 (tan (* (- 1.0 r) b)))
                        )
                        (apply 'append (cdr l))
                        (list z)
                    )
                )
            )
        )
    )
    (princ)
)

;; Tangent  -  Lee Mac
;; Args: x - real

(defun tan ( x )
    (if (not (equal 0.0 (cos x) 1e-10))
        (/ (sin x) (cos x))
    )
)

;; LW Vertices  -  Lee Mac
;; Returns a list of lists in which each sublist describes
;; the position, starting width, ending width and bulge of the
;; vertex of a supplied LWPolyline

(defun LM:LWVertices ( e )
    (if (setq e (member (assoc 10 e) e))
        (cons
            (list
                (assoc 10 e)
                (assoc 40 e)
                (assoc 41 e)
                (assoc 42 e)
            )
            (LM:LWVertices (cdr e))
        )
    )
)


(defun LM:Roundto ( n p / n p ) (/ (fix (+ (* n (setq p (expt 10. p))) (if (minusp n) -0.5 0.5))) p))
(defun LM:sublst ( lst idx len )
    (cond
        (   (null lst) nil)
        (   (< 0  idx) (LM:sublst (cdr lst) (1- idx) len))
        (   (null len) lst)
        (   (< 0  len) (cons (car lst) (LM:sublst (cdr lst) idx (1- len))))
    )
)

(defun IsPointOnVertex ( e p / param ) 
	
	(setq param (vlax-curve-getparamatpoint e p) )
	(if (equal ( rem param 1 ) 0.0 0.01 ) t nil  )
)

;;--------------------=={ Remove Vertex from LWPolyline  }==--------------------;;
;;                                                            					;;
;;  removes vertex from  LWPolyline at a point specified   		 				;;
;;------------------------------------------------------------------------------;;
;;  Author: Usugi Informatyczne Szansa , Copyright  2017 - www.ZWCAD.pl       ;;



(defun C:rmv ( / e p n param ep nearestVertex begin end VPosition NVPosition newDef segment bulgeAtSegment ) 
	(defun Init (  /  )
		(while
			(progn (setq p (getpoint "\nPick Vertex to remove: "))
				(cond
					(   (null p) nil)
					(   (null (setq e (nentselp p)))
						(princ "\nPoint does not lie on an LWPolyline.")
					)
					(   (= 4 (length e))
						(princ "\nObject is Nested.")
					)
					(   (/= "LWPOLYLINE" (cdr (assoc 0 (entget (setq e (car e))))))
						(princ "\nObject is not an LWPolyline.")
					)
				)
			)
		)	 
	)
	( Init )
	(if (and p e
            (setq p (vlax-curve-getclosestpointto e (trans p 1 0) ) )
            ; (setq n (vlax-curve-getparamatpoint e p) )
        )
		(progn
				; (vlax-dump-object (vlax-ename->vla-object(car(entsel))) t)
			(setq param (vlax-curve-getparamatpoint e p) )
			(setq n (LM:Roundto param 0 ) )
			(setq obj (vlax-ename->vla-object e ) )
			(setq enddef (entget e ) )
			(if (IsPointOnVertex e p ) (progn
								
				(setq nearestVertex (vlax-curve-getpointatparam e n))
				(setq anypoint (assoc 10 enddef))
				(setq ep (append (list 10 ) nearestVertex ) )
				( if ( = ( length anypoint ) 3 ) ( setq ep (reverse (cdr (reverse ep) ) )) )	; ZWCAD 2017 bugfix 1402
								
				(setq VPosition (vl-position ep enddef ) )
				
				
				(setq end (member (assoc 10 (cdr (member ep enddef ) )) enddef ) )
				(setq NVPosition (vl-position (car end) enddef ) )
				(setq begin ( LM:sublst enddef 0  VPosition ) )
				
				(setq newDef (append begin end))
				(entmod newDef)
				(if ( > n 0 )	(progn
					(vlax-invoke-method obj 'SetBulge (1- n ) 0.0)
				) )
			)
			(progn ; kliknity segment
				(setq segment (fix param ) )
				(setq bulgeAtSegment (vlax-invoke-method obj 'GetBulge param ) )
				
				(if (not (equal bulgeAtSegment 0.0 0.00001 ) ) (progn
					(vlax-invoke-method obj 'SetBulge segment 0.0)
				) )
			)
			)
		)
	)
	( princ )
)




;;------------------------------------------------------------;;
;;                        End of File                         ;;
;;------------------------------------------------------------;;


;;------------------------------------------------------------;;
;;    Tworzenie warstw wedug ustawie
;;------------------------------------------------------------;;


(defun Linetype:Load ( linetype filename / *error* doc path linetypes ans )
	 (defun *error* ( msg / ) 
		 (if (not (null msg ) )	(progn (princ "\nLinetype:Load:*error*: " ) (princ msg ) (princ "\n")	) )
	 )
	 (setq path (findfile filename ))
	 (if (not (null path ) ) (progn
		(setq doc (vla-get-activedocument (vlax-get-acad-object) ))
		( setq linetypes ( vlax-get-property doc 'Linetypes ) )
		
		(setq ans(vl-catch-all-apply 'vlax-invoke-method (list linetypes 'Load typlinii path ) ) ) 
	 ) )
	nil 
 )

	
 (defun Utworzwarstwe ( nazwa kolor typlinii SzerokoscLinii / *error* doc Warstwy Warstwa linetypes linetype )
	 (defun *error* ( msg / ) 
		 (if (not (null msg ) )	(progn (princ "\nUtworzwarstwe:*error*: " ) (princ msg ) (princ "\n")	) )
	 )
	 (setq doc (vla-get-activedocument (vlax-get-acad-object) ))
	 (setq Warstwy (vlax-get-property doc 'Layers ) )
	 (setq Warstwa (vlax-invoke-method Warstwy 'Add nazwa ) )
	 (vlax-put-property Warstwa 'Color kolor )
	 
	 ( setq linetypes ( vlax-get-property doc 'Linetypes ) )
	 (setq ltype(vl-catch-all-apply 'vlax-get-property (list linetypes 'Item typlinii )))
	 (if (vl-catch-all-error-p ltype ) (progn
		(Linetype:Load typlinii "zwcadiso.lin")
	 )
	 )
	 (setq ans(vl-catch-all-apply 'vlax-put-property (list Warstwa 'Linetype typlinii ) ) )
	 (if ( not ( null SzerokoscLinii ) )	 
		(setq ans(vl-catch-all-apply 'vlax-put-property (list Warstwa 'Lineweight SzerokoscLinii ) ) )
	 )
	 
 )
 
 
 (defun c:lstart (/)
 
	(Utworzwarstwe "Osie" 1 "Center" nil )
	(Utworzwarstwe "Ukryte" 254 "Hidden" nil )
	(Utworzwarstwe "Opisy" 253 "Continuous" zcLnWt030 )
	(Utworzwarstwe "Kreskowanie" 253 "Continuous" zcLnWt060 )
	(Utworzwarstwe "Wymiary" 7 "Continuous" nil )
	(princ "" )
 )
 
 
 
 
;;------------------------------------------------------------;;
;;    Tworzenie warstw wedug ustawie - KONIEC
;;------------------------------------------------------------;;



;;------------------------------------------------------------;;
;;    BBEDIT - edycja wskazanego bloku
;;------------------------------------------------------------;;

(defun C:BB (  / *error* SelectNestedBlock )
	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nC:BBedit:*error*: " ) (princ msg ) (princ "\n")	) )
	)
	(defun SelectNestedBlock (  / *error* sel mostNestedObject SelectedBlock aDoc blockId )
		(defun *error* ( msg / ) 
			(if (not (null msg ) )	(progn (princ "\nSelectNestedBlock:*error*: " ) (princ msg ) (princ "\n")	) )
			( exit )
		)
		
		(setq sel(vl-catch-all-apply 'nentsel (list "Wska blok do edycji")))
		  (if (not ( vl-catch-all-error-p sel ) )  (progn
			(setq mostNestedObject (vlax-ename->vla-object (car sel ) ) )
			(setq blockId (vlax-get-property mostNestedObject 'OwnerId ) )
			(setq aDoc (vlax-get-property (vlax-get-acad-object) 'ActiveDocument))
			(setq SelectedBlock ( vla-ObjectIDToObject aDoc blockId ) )
		  ) )
		  
		SelectedBlock
	)
	
	(setq selNestedBlock ( SelectNestedBlock ) )
	(if ( and (not (null selNestedBlock ) )
			  ( = (vlax-get-property selNestedBlock 'ObjectName ) "AcDbBlockTableRecord" )
			  ( = (vlax-get-property selNestedBlock 'IsLayout ) :VLAX-FALSE ) 
		)
		(command "_-BEDIT" (vlax-get-property selNestedBlock 'Name ) )

	)
	(princ  )
)


;;------------------------------------------------------------;;
;;    BBEDIT - edycja wskazanego bloku - KONIEC
;;------------------------------------------------------------;;




;;------------------------------------------------------------;;
;;    www.zwcad.pl | MDIST - suma odlegoci pomidzy wskazanymi punktami
;;------------------------------------------------------------;;

(defun C:MDist ( / Sumlen Endloop)
	(setq Endloop t)
	(setq SumLen 0)
	(setq P0(vl-catch-all-apply 'getpoint (list  "\nWska punkt ")))
	(if (not(vl-catch-all-error-p P0))
		(progn
			(while Endloop
				(setq Px(vl-catch-all-apply 'getpoint (list P0 "")))
				(if (not(vl-catch-all-error-p Px))
					(progn	
						(if Px 
							(progn
								(princ (strcat "\n Suma dugoci wynosi: " (rtos(setq Sumlen (+ Sumlen (distance P0 Px))) 2 4)))
								(setq P0 Px)
								(setq Px nil)
							)
							(progn (setq Endloop nil))
						)
					)
					(progn (setq Endloop nil))
				)
			)
		)
	)
	(princ)
)

(Princ)

;;------------------------------------------------------------;;
;;    www.zwcad.pl | MDIST - suma odlegoci pomidzy wskazanymi punktami
;;------------------------------------------------------------;;




;;------------------------------------------------------------;;
;;    Perlon | https://forum.cad.info.pl/profile/234-perlon/ | Lisp2Zel - suma odlegoci pomidzy wskazanymi punktami
;;------------------------------------------------------------;;


(defun c:Lsp2Zel ( / dcl_id action sourceFile targetFile)
	(vl-load-com)
	
	(defun YesNo (BoxTitle Question / dcl_id result acadfn fn fid)	
		(if	(and 
				(setq fn (vl-filename-mktemp "YesNo.dcl"))	
				(setq fid (open fn "w"))
			)
			(progn
				(foreach x
					(list
						"YesNo : dialog {"
						"key = \"Title\";"
						"spacer;"
						": text {"
						"key = \"Question\";"
						(strcat 
							"width = "
							(itoa (strlen Question))
							";"
						)
						"alignment = centered;"
						"}"
						"spacer;"
						": row {"
						"fixed_width = true;"
						"alignment = centered;"
						": button {"
						"key = \"Yes\";"
						"label = \"&Tak\";"
						"is_default = true;"
						"}"
						": button {"
						"key = \"No\";"
						"label = \"&Nie\";"
						"is_cancel = true;"
						"}"
						"}"
						"}"
					)
					(princ x fid)
					(write-line "" fid)
				)
				(close fid)
			)
		)
		(cond
			(
				(setq dcl_id (load_dialog fn))
				(new_dialog "YesNo" dcl_id)
				(set_tile "Title" BoxTitle)
				(set_tile "Question" Question)
				(action_tile "Yes" "(done_dialog 1)")
				(action_tile "No" "(done_dialog 0)")
				(setq result (start_dialog))
				(unload_dialog dcl_id)
				(vl-file-delete fn)
				(if (and result (= result 1)) "Yes" "No")
			)
			(t nil)
		)
	)	
	
	(defun create_dialog ( / fn fid)
		(if	(and 
				(setq fn (vl-filename-mktemp "Lisp2Zel.dcl"))	
				(setq fid (open fn "w"))
			)
			(progn
				(foreach x
					(list
						"Lisp2Zel : dialog {"
						"label = \"LSP2ZEL\";"
						"fixed_width=true;"
						": row {"
						"alignment=centered;"
						": text {"
						"value = \"Plik rdowy:\";"
						"fixed_width = true;"
						"width = 12;"
						"}"
						": edit_box {"
						"key = \"source\";"
						"alignment = centered;"
						"edit_limit = 120;"
						"edit_width = 50;"
						"}"
						": button {"
						"label = \"...\";"
						"fixed_width = true;"
						"width = 4;"
						"key = \"get_source\";"
						"}"
						"}"
						": row {"
						"alignment = centered;"
						": text {"
						"value = \"Plik docelowy:\";"
						"fixed_width = true;"
						"width = 12;"
						"}"
						": edit_box {"
						"key = \"target\";"
						"alignment = centered;"
						"edit_limit = 120;"
						"edit_width = 50;"
						"}"
						": button {"
						"label = \"...\";"
						"fixed_width = true;"
						"width = 4;"
						"key = \"get_target\";"
						"}"
						"}"
						": row {"
						"fixed_width = true;"
						"alignment = centered;"
						": button {"
						"label = \"Szyfruj\";"
						"key = accept;"
						"fixed_width = true;"
						"width = 15;"
						"is_default = true;"
						"}"
						": button {"
						"label = \"Anujluj\";"
						"key = \"cancel\";"
						"fixed_width = true;"
						"width = 15;"
						"is_cancel = true;"
						"}"
						"}"
						"}"
					)
					(princ x fid)
					(write-line "" fid)
				)
				(close fid)
				(load_dialog fn)
			)
		)
	)
	
	(defun is_empty ( arg )
		(or (not arg) (= arg ""))
	)
	
	(defun get_source_file( / source)
		(if (setq source (getfiled "Wska plik" sourceFile "lsp" 32))
			(set_tile "source" (setq sourceFile source))
		)
		(if (is_empty targetFile)
			(set_tile "target" (setq targetFile (strcat (vl-filename-directory sourceFile) "\\" (vl-filename-base sourceFile) ".zel")))
		)
		(accept_mode)
	)

	(defun get_target_file( / target)
		(if (setq target (getfiled "Wska miejsce docelowe" targetFile "zel" 33))
			(set_tile "target" (setq targetFile target))
		)
		(accept_mode)
	)

	(defun accept_mode ( / )
		(if (is_empty sourceFile)
			(mode_tile "get_source" 2)
			(if (is_empty targetFile)
				(mode_tile "get_target" 2)
				(mode_tile "accept" 2)
			)
		)
	)

	(defun dialog_handling ( / )
		(set_tile "source" sourceFile) 
		(set_tile "target" targetFile) 
		(action_tile "source" "")
		(action_tile "get_source" "(get_source_file)")
		(action_tile "target" "")
		(action_tile "get_target" "(get_target_file)")
		(action_tile "cancel" "(done_dialog 0)")
		(action_tile "accept" "(done_dialog 1)")
		(mode_tile "source" 1)
		(mode_tile "target" 1)
	)
	
	(defun compile ( src tar / )
		(if (compile-zelx src tar)
			(alert "Szyfrowanie zakoczone pomylnie")
		)
	)
	
	(setq action 1
		  sourceFile ""
		  targetFile ""
	)
	(if (= (getvar "PRODUCT") "ZWCAD")
		(if (setq dcl_id (create_dialog))
			(progn
				(while (> action 0)
					(new_dialog "Lisp2Zel" dcl_id)
					(dialog_handling)
					(setq action (start_dialog))
					(if (= action 1)
						(if (is_empty sourceFile) 
							(alert "Nie wskazano pliku rdowego")
							(if (is_empty targetFile) 
								(alert "Nie wskazano pliku docelowego") 
								(if (findfile sourceFile) 
									(if (findfile targetFile) 
										(if (= (YesNo "Uwaga" (strcat "Czy chcesz zastpi istniejcy plik " targetFile "?")) "Yes") 
											(compile sourceFile targetFile)
										) 
										(compile sourceFile targetFile)
									)
									(alert (strcat "Nie znaleziony plik " sourceFile))
								)
							)
						)
					)
				)
				(unload_dialog dcl_id)
			)
			(princ "\nBd obsugi okna dialogowego")
		)
		(princ "\nFunkcja dziaa wycznie w rodowisku ZwCAD")
	)
	(princ)
)
























;;------------------------------------------------------------;;
;;    Perlon | https://forum.cad.info.pl/profile/234-perlon/ | Lisp2Zel - suma odlegoci pomidzy wskazanymi punktami
;;------------------------------------------------------------;;




;;------------------------------------------------------------;;
;; Pac GC - Changer le style de Multi-Lignes ...
;; http://www.cadxp.com/modules.php?op=modload&name=XForum&file=viewthread&tid=30135#pid130971
;; Commande : CMLS

(defun c:CMLS (/ *error* echo osnp slst ss styl ent)
  (vl-load-com)
  (defun *error* (msg)
    (or (not msg)
        (= msg "Fonction annule")
        (princ (strcat "Erreur: " msg))
    )
    (setvar 'cmdecho echo)
    (setvar 'osmode osnp)
    (vla-EndUndoMark (vla-get-ActiveDocument (vlax-get-acad-object)))
    (princ)
  )
  (setq echo (getvar 'cmdecho)
        osnp (getvar 'osmode)
        slst (gc:GetDictEntries (dictsearch (namedobjdict) "ACAD_MLINESTYLE"))
  )
  (if
    (and
      (setq n  -1
            ss (ssget '((0 . "MLINE")))
      )
      (setq styl (gc:ListBox "Styles de multiligne" "Choisissez un style" (mapcar 'car slst) 0))
    )
     (progn
       (vla-StartUndoMark (vla-get-ActiveDocument (vlax-get-acad-object)))
       (setvar 'cmdecho 0)
       (setvar 'osmode 0)
       (while (setq ent (ssname ss (setq n (1+ n))))
         (setq elst (entget ent))
         (vl-cmdf "_.mline" "_style" styl)
         (mapcar '(lambda (x)
                    (vl-cmdf (trans x 0 1))
                  )
                 (massoc 11 elst)
         )
         (vl-cmdf (if (= 2 (logand 2 (cdr (assoc 71 elst))))
                    "_close"
                    ""
                  )
         )
         (if (setq xd (assoc -3 (entget ent '("*"))))
           (entmod (append (entget (entlast)) (list xd)))
         )
         (entdel ent)
       )
     )
  )
  (*error* nil)
)

;; gc:ListBox par GC
;; Boite de dialogue permettant un ou plusieurs choix dans une liste
;;
;; Arguments
;; title : le titre de la boite de dialogue (chane)
;; msg ; message (chane), "" ou nil pour aucun
;; lbls : une liste de chanes (sans doublons)
;; flag : 0 = liste droulante
;;        1 = liste choix unique
;;        2 = liste choix multipes
;;
;; Retour : l'option (flag = 0 ou 1) ou la liste des options (flag = 2)
;;
;; Exemple d'utilisation
;; (listbox "Prsentation" "Choisir une prsentation" (layoutlist) 1)

(defun gc:ListBox (title msg lbls flag / tmp file dcl_id choice)
  (setq tmp  (vl-filename-mktemp "tmp.dcl")
        file (open tmp "w")
  )
  (write-line
    (strcat "ListBox:dialog{label=\"" title "\";")
    file
  )
  (if (and msg (/= msg ""))
    (write-line (strcat ":text{label=\"" msg "\";}") file)
  )
  (write-line
    (cond
      ((= 0 flag) "spacer;:popup_list{key=\"lst\";")
      ((= 1 flag) "spacer;:list_box{key=\"lst\";")
      (T "spacer;:list_box{key=\"lst\";multiple_select=true;")
    )
    file
  )
  (write-line "}spacer;ok_cancel;}" file)
  (close file)
  (setq dcl_id (load_dialog tmp))
  (if (not (new_dialog "ListBox" dcl_id))
    (exit)
  )
  (start_list "lst")
  (mapcar 'add_list lbls)
  (end_list)
  (action_tile
    "accept"
    "(or (= (get_tile \"lst\") \"\")
    (if (= 2 flag) (progn
    (foreach n (gc:str2lst (get_tile \"lst\") \" \")
    (setq choice (cons (nth (atoi n) lbls) choice)))
    (setq choice (reverse choice)))
    (setq choice (nth (atoi (get_tile \"lst\")) lbls))))
    (done_dialog)"
  )
  (start_dialog)
  (unload_dialog dcl_id)
  (vl-file-delete tmp)
  choice
)

;; gc:str2lst
;; Transforme un chaine avec sparateur en liste de chaines
;;
;; Arguments
;; str : la chaine a transformer en liste
;; sep : le sparateur
;;
;; Exemples
;; (str2lst "a b c" " ") -> ("a" "b" "c")
;; (str2lst "1,2,3" ",") -> ("1" "2" "3")
;; (mapcar 'read (str2lst "1,2,3" ",")) -> (1 2 3)

(defun gc:str2lst (str sep / pos)
  (if (setq pos (vl-string-search sep str))
    (cons (substr str 1 pos)
          (gc:str2lst (substr str (+ (strlen sep) pos 1)) sep)
    )
    (list str)
  )
)

;; gc:GetDictEntries
;; Retourne la liste des entres du dictionnaire
;; sous forme de paires pointes (Nom . ENAME)
;;
;; Argument : dict le dictionnaire (ENAME ou liste DXF)

(defun gc:GetDictEntries (dict / result)
  (and (= (type dict) 'ENAME) (setq dict (entget dict)))
  (while
    (setq dict (vl-member-if (function (lambda (x) (= (car x) 3))) (cdr dict)))
     (setq result (cons (cons (cdar dict) (cdadr dict)) result))
  )
  (reverse result)
)

;; massoc
;; Retourne la liste de toutes les valeurs pour le code spcifi
;; dans une liste d'association
;;
;; Arguments
;; code : le code de groupe pour les entres
;; alst : la liste d'association

(defun massoc (code alst / pair)
  (if (setq alst (member (assoc code alst) alst))
    (cons (cdar alst) (massoc code (cdr alst)))
  )
)
 
;; Pac GC - Changer le style de Multi-Lignes ...
;; http://www.cadxp.com/modules.php?op=modload&name=XForum&file=viewthread&tid=30135#pid130971
;; Commande : CMLS
;;------------------------------------------------------------;;




;;------------------------------------------------------------;;
;;    https://forums.augi.com/showthread.php?168619-Automatically-dimension-all-sides-and-angles-of-selected-polylines-polygons&p=1335126&viewfull=1#post1335126
;;------------------------------------------------------------;;



(defun c:dimpolygons ( / *error* mr_IsPointInside mid adoc sel lay d ts i lw enx pl lwn enxn plni plno plnom plm )

  (vl-load-com)

  (defun *error* ( m )
    (if lay
      (setvar 'clayer lay)
    )
    (vla-endundomark adoc)
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun mr_IsPointInside ( pt ptlst / trianglst ptinsidetriangle-p trl )

    (defun trianglst ( ptlst / unique LM:ListClockwise-p clockwise-p l p1 p2 p3 trl )

      (defun unique ( l )
        (if l (cons (car l) (unique (vl-remove-if (function (lambda ( x ) (equal x (car l) 1e-6))) l))))
      )

      ;; List Clockwise-p - Lee Mac
      ;; Returns T if the point list is clockwise oriented

      (defun LM:ListClockwise-p ( lst )
        (minusp
          (apply '+
            (mapcar
              (function
                (lambda ( a b )
                  (- (* (car b) (cadr a)) (* (car a) (cadr b)))
                )
              )
              lst (cons (last lst) lst)
            )
          )
        )
      )

      (defun clockwise-p ( p1 p2 p3 )
        (< (* (- (car  p2) (car  p1)) (- (cadr p3) (cadr p1)))
           (* (- (cadr p2) (cadr p1)) (- (car  p3) (car  p1)))
        )
      )

      (setq l ptlst)
      (while (> (length ptlst) 3)
        (setq p1 (car ptlst) p2 (cadr ptlst) p3 (caddr ptlst))
        (cond
          ( (LM:ListClockwise-p ptlst)
            (if
              (and
                (clockwise-p p1 p2 p3)
                (= (length (unique (vl-remove nil (mapcar (function (lambda ( a b ) (inters p1 p2 a b))) l (cdr (reverse (cons (car l) (reverse l)))))))) 2)
                (= (length (unique (vl-remove nil (mapcar (function (lambda ( a b ) (inters p2 p3 a b))) l (cdr (reverse (cons (car l) (reverse l)))))))) 2)
                (= (length (unique (vl-remove nil (mapcar (function (lambda ( a b ) (inters p3 p1 a b))) l (cdr (reverse (cons (car l) (reverse l)))))))) 2)
              )
              (progn
                (setq trl (cons (list p1 p2 p3) trl))
                (setq ptlst (vl-remove p2 ptlst))
                (setq ptlst (cdr (reverse (cons (car ptlst) (reverse ptlst)))))
              )
              (setq ptlst (cdr (reverse (cons (car ptlst) (reverse ptlst)))))
            )
          )
          ( (not (LM:ListClockwise-p ptlst))
            (if
              (and
                (not (clockwise-p p1 p2 p3))
                (= (length (unique (vl-remove nil (mapcar (function (lambda ( a b ) (inters p1 p2 a b))) l (cdr (reverse (cons (car l) (reverse l)))))))) 2)
                (= (length (unique (vl-remove nil (mapcar (function (lambda ( a b ) (inters p2 p3 a b))) l (cdr (reverse (cons (car l) (reverse l)))))))) 2)
                (= (length (unique (vl-remove nil (mapcar (function (lambda ( a b ) (inters p3 p1 a b))) l (cdr (reverse (cons (car l) (reverse l)))))))) 2)
              )
              (progn
                (setq trl (cons (list p1 p2 p3) trl))
                (setq ptlst (vl-remove p2 ptlst))
                (setq ptlst (cdr (reverse (cons (car ptlst) (reverse ptlst)))))
              )
              (setq ptlst (cdr (reverse (cons (car ptlst) (reverse ptlst)))))
            )
          )
        )
      )
      (setq trl (cons (list (car ptlst) (cadr ptlst) (caddr ptlst)) trl))
      trl
    )

    (defun ptinsidetriangle-p ( pt p1 p2 p3 )
      (and
        (not
          (or
            (inters pt p1 p2 p3)
            (inters pt p2 p1 p3)
            (inters pt p3 p1 p2)
          )
        )
        (not
          (or
            (> (+ (distance pt p1) (distance pt p2)) (+ (distance p3 p1) (distance p3 p2)))
            (> (+ (distance pt p2) (distance pt p3)) (+ (distance p1 p2) (distance p1 p3)))
            (> (+ (distance pt p3) (distance pt p1)) (+ (distance p2 p3) (distance p2 p1)))
          )
        )
      )
    )

    (setq trl (trianglst ptlst))
    (vl-some (function (lambda ( x ) (ptinsidetriangle-p pt (car x) (cadr x) (caddr x)))) trl)
  )

  (defun mid ( p1 p2 )
    (mapcar (function (lambda ( a b ) (/ (+ a b) 2.0))) p1 p2)
  )

  (vla-startundomark (setq adoc (vla-get-activedocument (vlax-get-acad-object))))
  (prompt "\nSelect closed POLYGONS...")
  (setq sel (ssget (list '(0 . "LWPOLYLINE") '(-4 . "&=") '(70 . 1) '(-4 . "<not") '(-4 . "<>") '(42 . 0.0) '(-4 . "not>"))))
  (setq lay (getvar 'clayer))
  (initget 7)
  (setq d (getdist "\nPick or specify offset distance for dimensioning : "))
  (setq ts (/ d 2.0))
  (setvar 'dimtxsty "Standard")
  (setvar 'dimjust 0)
  (setvar 'dimtad 0)
  (setvar 'dimtih 0)
  (setvar 'dimupt 0)
  (setvar 'dimtix 1)
  (setvar 'dimtofl 1)
  (setvar 'dimaunit 1)
  (setvar 'dimlunit 2)
  (setvar 'dimadec 1)
  (setvar 'dimdec 2)
  (setvar 'dimasz (/ ts 2.0))
  (vla-put-height (vlax-ename->vla-object (tblobjname "STYLE" "Standard")) ts)
  (if sel
    (progn
      (repeat (setq i (sslength sel))
        (setq lw (ssname sel (setq i (1- i))))
        (setq enx (entget lw))
        (setq pl (mapcar (function (lambda ( x ) (trans (list (car x) (cadr x) (cdr (assoc 38 enx))) lw 1))) (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) enx))))
        (vla-offset (vlax-ename->vla-object lw) d)
        (setq lwn (entlast))
        (setq enxn (entget lwn))
        (setq plni (mapcar (function (lambda ( x ) (trans (list (car x) (cadr x) (cdr (assoc 38 enxn))) lwn 1))) (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) enxn))))
        (if (not (mr_IsPointInside (car plni) pl))
          (progn
            (entdel lwn)
            (vla-offset (vlax-ename->vla-object lw) (- d))
            (setq lwn (entlast))
            (setq enxn (entget lwn))
            (setq plni (mapcar (function (lambda ( x ) (trans (list (car x) (cadr x) (cdr (assoc 38 enxn))) lwn 1))) (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) enxn))))
          )
        )
        (entdel lwn)
        (setq plno (mapcar (function (lambda ( a b ) (mapcar (function +) a (mapcar (function -) a b)))) pl plni))
        (setq plnom (mapcar (function (lambda ( a b ) (mid a b))) plno (cdr (reverse (cons (car plno) (reverse plno))))))
        (if (not (tblsearch "LAYER" "DIMALIGNED"))
          (command "_.-LAYER" "_M" "DIMALIGNED" "")
          (progn
            (command "_.-LAYER" "_T" "DIMALIGNED" "")
            (setvar 'clayer "DIMALIGNED")
          )
        )
        (mapcar (function (lambda ( a b c ) (command "_.DIMALIGNED" "_non" a "_non" b "_non" c))) pl (cdr (reverse (cons (car pl) (reverse pl)))) plnom)
        (if (not (tblsearch "LAYER" "DIMANGULAR"))
          (command "_.-LAYER" "_M" "DIMANGULAR" "")
          (setvar 'clayer "DIMANGULAR")
        )
        (command "_.-LAYER" "_F" "DIMALIGNED" "")
        (setq pl (reverse (cons (car pl) (reverse pl))))
        (setq plm (mapcar (function (lambda ( a b ) (mid a b))) pl (cdr pl)))
        (mapcar (function (lambda ( a b c d ) (command "_.DIMANGULAR" "" "_non" a "_non" b "_non" c "_non" d))) (cdr pl) plm (cdr (reverse (cons (car plm) (reverse plm)))) (cdr (reverse (cons (car plni) (reverse plni)))))
      )
      (command "_.-LAYER" "_T" "DIMALIGNED" "")
    )
    (prompt "\nEmpty sel. set... Retry routine with valid sel. set...")
  )
  (*error* nil)
)


;;------------------------------------------------------------;;
;;    https://forums.augi.com/showthread.php?168619-Automatically-dimension-all-sides-and-angles-of-selected-polylines-polygons&p=1335126&viewfull=1#post1335126
;;------------------------------------------------------------;;




;;------------------------------------------------------------;;
;;https://forum.cad.info.pl/topic/3145-szyk-manualny/
;;------------------------------------------------------------;;



(defun C:SzykManualny (  / element odleglosc bazowy kierunek 
							Koniec licznik

	*error* )	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nC:SzykManualny:*error*: " ) (princ msg ) (princ "\n")	) )
	)
	(setq Koniec ""
			licznik 1 )
	
	(defun kopiuj (  / v1 v % clone px
		*error* )	(defun *error* ( msg / ) 
			(if (not (null msg ) )	(progn (princ "\nkopiuj:*error*: " ) (princ msg ) (princ "\n")	) )
		)
		( setq v1 ( Vector:Normalize ( Vector: kierunek bazowy  ) ) ) 
		( setq v  ( Vector:XScalar v1 (* odleglosc licznik ) ) )
		(foreach % elementy
			( setq clone (vlax-invoke-method % 'Copy) )
			( setq px (Vector+ bazowy v ))
			(vlax-invoke-method clone 'Move (vlax-3d-point bazowy) (vlax-3d-point px)  )
		)
		(setq licznik (1+ licznik)) 
	)
	
	
	(setq elementy ( SelSet:Get "Wska elementy" nil))
		(if (null elementy) (*error* nil) )
	(setq odleglosc (ZWCAD:GetDist "Podaj odlego" poprzedniaOdleglosc))
		(if (null odleglosc) (*error* nil) )
	(setq bazowy (ZWCAD:Getpoint "Wska punkt bazowy" nil nil ) )
		(if (null bazowy) (*error* nil) )
	(setq kierunek (ZWCAD:Getpoint "Wska kierunek" bazowy nil ) )
		(if (null kierunek) (*error* nil) )
	(while	(equal Koniec "")
		( kopiuj )
		(setq Koniec ( ZWCAD:GetString "Czy wstawi kolejny" "" ) )
	)
	
	(setq poprzedniaOdleglosc odleglosc)
	(princ)
)

(defun Vector: ( A B /
  *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nVector::*error*: " ) (princ msg ) (princ "\n")	) )
	)       
	(list 
		(- (car A) (car B ) )
		(- (cadr A) (cadr B ) )
		(- (caddr A) (caddr B ) )
	)
)

(defun Vector:Length (vec / s 
 *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nVector:Length:*error*: " ) (princ msg ) (princ "\n")	) )
	)       
	(setq s (+ (* (car vec) (car vec) ) (* (cadr vec) (cadr vec) ) (* (caddr vec) (caddr vec) )))
	(if (< s 0.0000000000001 ) 0.0 (sqrt s ))
) 
(defun Vector:Normalize (v / len 
	*error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nVector:Normalize:*error*: " ) (princ msg ) (princ "\n")	) )
	)       
	(setq len (Vector:Length v) )
	(if (< len 0.00000001)	
		(list 0.0 0.0 0.0 )
		(progn
			(list 	(/ (car v ) len)
					(/ (cadr v ) len)
					(/ (caddr v ) len)	
			)
		)
	)
)


(defun Vector:XScalar (v s / 
 *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nVector:XScalar :*error*: " ) (princ msg ) (princ "\n")	) )
	)      
	(mapcar '(lambda (x) (* x s) ) v )
)

(defun Vector+ (A B / 
 *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\n Vector+ : *error*: " ) (princ msg ) (princ "\n")	) )
	)                  
	(if (null A) (setq A (list 0.0 0.0 0.0  ) ))
	(if (null B) (setq B (list 0.0 0.0 0.0  ) ))
	(list 
		(+ (car A ) (car B) )
		(+ (cadr A ) (cadr B) )
		(+ (caddr A ) (caddr B ) )
	)
)


(defun SelSet:ToList (selset / Wynik ileelementow i 
 *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nSelSet:ToList:*error*: " ) (princ msg ) (princ "\n")	) )
	)      
 (if selset (progn
 (setq ileelementow(sslength selset) )
 (setq i 0 )
 (repeat ileelementow
	(setq Wynik (append Wynik (list (vlax-ename->vla-object(ssname selset i) ) )))
	(setq i (1+ i ))
 )
 ))
 Wynik
)

(defun SelSet:FilterByType ( elementy typy / sl i % 
 *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nSelSet:FilterByType:*error*: " ) (princ msg ) (princ "\n")	) )
	)      
; (setq elementy (ssget ) )
  (setq sl (sslength elementy))
  (setq i (1- sl ))
    (repeat sl
	  (setq % (ssname elementy i))
	  
	  (if (not (member (cdr(assoc 0 (entget %) )) typy))
		(setq elementy(ssdel % elementy))
	  )
      (setq i (1- i) )
    )
)


(defun SelSet:Filter ( elementy filtr / sl i % 
 *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nSelSet:Filter:*error*: " ) (princ msg ) (princ "\n")	) )
	)      
;	(SelSet:Filter (ssget) (list (cons 2 "ZWGEO_Pt" ) ))
; (setq elementy (ssget ) )		(setq filtr (list (cons 0 "INSERT") ))

(setq sl (sslength elementy))
  (setq i (1- sl ))
    (repeat sl
	  (setq % (ssname elementy i))
	  (foreach ^ filtr		; (setq ^ (nth 0 filtr))
		(if (not(member ^ (entget %)))	  
			(setq elementy(ssdel % elementy))
		)
	  )
      (setq i (1- i) )
    )
	elementy
)


(defun SelSet:Get (tresc typy / selElems elementy Filter % OldNoMutt  
 *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\n SelSet:Get:*error*: " ) (princ msg ) (princ "\n")	) )
	)      		
;----------------------------------------------------------
; funkcja sprawdza, czy jakie elementy zostay zaznaczone, jeli nie, prosi uytkownika o wskazanie obiektw
; Argumenty: tresc - komunikat wywietlany w pasku polece zachta do wskazanie obiektw
; Wynik: lista wybranych obiektw jeli co zostao wybranie
;		 nil jeli nic nie zostao wybrane.
; ----------------------------------------------------------
; versja 2.0
; dodane filtrowanie typw
; ----------------------------------------------------------
; test:
;(sslength (ssget (list (cons 0  "3DSOLID") )))
; ----------------------------------------------------------


(if typy (progn
	(if (listp (car typy) ) 
		(setq Filter typy )
	(progn
		(setq Filter (list (cons -4 "<or" )))
		(foreach % typy
			(setq Filter (append Filter  (list (cons 0 % ) )))
		)
		(setq Filter (append Filter  (list (cons -4 "or>" ) )))	
	)
	)
))
 

  (setq selElems(ssgetfirst ))
  (if (car selElems)
	(progn
		(setq elementy (SelSet:ToList(SelSet:FilterByType selElems typy)))
	)
	(progn
	   (setq tresc (strcat "\n" tresc ": ") )
	   (princ tresc )
	   (setq OldNoMutt (getvar 'NOMUTT))	
	   (setvar 'NOMUTT 1)
	   (setq elementy
				(if (null Filter)
					(vl-catch-all-apply 'ssget )
					(vl-catch-all-apply 'ssget (list Filter ))
				)
		)
		(setvar 'NOMUTT OldNoMutt )
	   
	   (if (not(vl-catch-all-error-p elementy))
		  (progn
		    (setq elementy (SelSet:ToList elementy ))
		  )
		  (progn 
			(setq elementy nil)
		  )
		)
	)  
  )
  elementy
)


(defun SelSet:Entsel (tresc filter / OldNoMutt MSel OutVal 
 *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nSelSet:Entsel:*error*: " ) (princ msg ) (princ "\n")	) )
	)      

	(setq tresc (strcat "\n" tresc ": ") )
	(prompt tresc )
	
	(setq OldNoMutt (getvar 'NOMUTT))	
	(setvar 'NOMUTT 1)	
	(setq MSel
		(if (null filter)
			(vl-catch-all-apply 'ssget (list ":S:E" ))
			(vl-catch-all-apply 'ssget (list ":S:E" filter ))
		)
	)
		
	(setvar 'NOMUTT OldNoMutt )
	(if (vl-catch-all-error-p MSel)
	(progn
		(prompt (vl-catch-all-error-message MSel))
	)
	(progn
	  (if MSel (progn		
		(setq OutVal (vlax-ename->vla-object  (ssname MSel 0)) )			
	  ))
	)
	)
	OutVal
)


(defun ZWCAD:GetDist (tresc domyslny / Wynik trescformat liczba  
	*error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nZWCAD:GetDist:*error*: " ) (princ msg ) (princ "\n")	) )
	)      	
	(if domyslny (if (numberp domyslny) (setq tresc (strcat tresc "<" (rtos domyslny 2 4) ">") )))
	(setq tresc (strcat "\n" tresc ": "))
	(setq liczba(vl-catch-all-apply 'getdist (list tresc )))
	(if (vl-catch-all-error-p liczba)
	(progn
		(prompt (vl-catch-all-error-message liczba))
		(setq Wynik nil )
	)
	(progn
	  (if (null liczba) 
		(setq Wynik domyslny )
		(setq Wynik liczba)
	  )
	)
  )
  Wynik
)


(defun ZWCAD:Getpoint (tresc P0 domyslny / SelPt Wynik 
 *error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nZWCAD:Getpoint:*error*: " ) (princ msg ) (princ "\n")	) )
	)      
;(ZWCAD:Getpoint tresc P0 domyslny )
	(setq tresc (strcat "\n" tresc ": "))
	(if (not(null P0))
		(setq SelPt(vl-catch-all-apply 'getpoint (list P0 tresc )))
		(setq SelPt(vl-catch-all-apply 'getpoint (list  tresc )))
	)
	(if (vl-catch-all-error-p SelPt)
	(progn
		(prompt (vl-catch-all-error-message SelPt))
		(setq Wynik nil )
	)
	(progn				
	  (if (null SelPt) 
		(setq Wynik domyslny )
		(setq Wynik SelPt)
	  )
	)
  )
  Wynik
)


(defun ZWCAD:GetString (tresc domyslny / 
	*error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nZWCAD:GetString:*error*: " ) (princ msg ) (princ "\n")	) )
	)      
	(setq tresc (strcat "\n" tresc ": "))
	(String:Get tresc domyslny)
)

(defun String:Get (komunikat defVal / Wynik tekst 
	*error* ) 	(defun *error* ( msg / ) 
		(if (not (null msg ) )	(progn (princ "\nString:Get:*error*: " ) (princ msg ) (princ "\n")	) )
	)      
	;	(setq komunikat "podaj tekst" )
	;	(setq defVal "SLU" )
	 
	(if defVal (if (not(= defVal "")) (setq komunikat (strcat komunikat "<" defVal ">:" ) )) )
	(setq tekst(vl-catch-all-apply 'getstring (list komunikat )))
	(if (vl-catch-all-error-p tekst)
	(progn
		(prompt (vl-catch-all-error-message tekst))
		(setq Wynik nil )
	)
	(progn
	  (if (null tekst) 
		(setq Wynik defVal )
		(if (= tekst "")
			(setq Wynik defVal )
			(if (= tekst ".")
				(setq Wynik "")
				(setq Wynik tekst)
			)
		)
	  )
	)
  )
  Wynik

)


;;------------------------------------------------------------;;
;;https://forum.cad.info.pl/topic/3145-szyk-manualny/
;;------------------------------------------------------------;;
